#!/bin/sh
while true;do
	wanlist=$(uci show network|grep interface|grep -v lan|grep -v loopback|grep -v wan6|grep -v JXJSQ|awk -F "." '{print $2}'|awk -F "=" '{print $1}')	
	for interface in `echo $wanlist`;do
		interfaceproto=$(ifstatus $interface|grep proto|awk -F "\"" '{print $4}')
		if [ "$interfaceproto" != "dhcpv6" ];then
			nexthop=$(ifstatus $interface|grep nexthop|tail -1|awk -F "\"" '{print $4}')
			if [ -n "$nexthop" ];then
				wandevice=$(ifstatus $interface|grep \"l3_device|tail -1|awk -F "\"" '{print $4}')
				ping -4 -c 2 -I $wandevice 114.114.114.114 >/dev/null 2>&1
				if [ "$?" = "0" ];then
					break 2
				fi
			fi
		fi
	done
	echo "check fail.recheck internet"
	sleep 3
done

iptables -F wlist_DROP
iptables -F wlist_forward
iptables -F wlist_ACCEPT

iptables -N wlist_DROP -m comment --comment wlist
iptables -A wlist_DROP -m comment --comment wlist -o $wandevice -j DROP
iptables -A wlist_DROP -m comment --comment wlist -o vpn-JXJSQ1 -j DROP
iptables -A wlist_DROP -m comment --comment wlist -o vpn-JXJSQ2 -j DROP


iptables -N wlist_ACCEPT -m comment --comment wlist
iptables -A wlist_ACCEPT -m comment --comment wlist -o $wandevice -j ACCEPT
iptables -A wlist_ACCEPT -m comment --comment wlist -o vpn-JXJSQ1 -j ACCEPT
iptables -A wlist_ACCEPT -m comment --comment wlist -o vpn-JXJSQ2 -j ACCEPT


iptables -N wlist_forward -m comment --comment wlist
i=0
for oldmac in `cat /etc/wlistd.user`;do
	iptables -D wlist_forward -m comment --comment wlist -m mac --mac-source $oldmac -j wlist_ACCEPT
done
	
for mac in `cat /etc/wlist.user`;do
	i=1
	iptables -I wlist_forward -m comment --comment wlist -m mac --mac-source $mac -j wlist_ACCEPT
done

if [ "$i" = "0" ];then
	echo no wlist mac add.
else
	cp /etc/wlist.user /etc/wlistd.user
	iptables -A wlist_forward -m comment --comment wlist -j wlist_DROP
	iptables -D delegate_forward -j wlist_forward
	iptables -I delegate_forward -j wlist_forward
	echo wlist add complete.
fi



